#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "modulo.h"
#include "callbacks.h"
#include "prefer_int.h"
#include "interface.h"
#include "dialoghi.h"
#include "support.h"
#include "error.h"
#include "file.h"

#include "rubrica.h"

void
on_new_file1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_crea_nuovo_archivio();
}



void	
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_carica_file();
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_salva_file(NULL, NULL);
  rubrica_modificata(FALSE);
}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_salva_file_come(NULL,NULL);
  rubrica_modificata(FALSE);
}

void 
esci(void)
{
  gchar *mes;
  gint scelta;
  
  if (rubrica_is_modificata())
    mes = g_strdup(_("Attenzione. La rubrica  stata modificata.\nI cambiamenti\
 non salvati saranno persi.\n Continuo?"));
  else 
    mes = g_strdup(_("\nVuoi uscire da rubrica?"));
  
  scelta = confermare_uscita(mes);
  g_free(mes);
  
  switch(scelta)
    {
    case 0:
      gtk_main_quit();
      break;
      
    case 1:
    default:
      break;
    }  
}

void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  esci();
}


void 
on_undo_activate (GtkMenuItem     *menuitem,
		  gpointer         user_data)
{
  non_implementato();
}

void
on_redo_activate (GtkMenuItem     *menuitem,
		  gpointer         user_data)
{
  non_implementato();
}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  non_implementato();
  
}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  non_implementato();

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  non_implementato();

}


void
on_alfabetica1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_alfabetico();
}


void
on_dimensione1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_grandezza();
}


void
on_data1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_data();
}


void
on_crescente1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_crescente();
}


void
on_decrescente1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  rubrica_ordinamento_set_decrescente();
}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  create_propertybox();
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  info();
}


void
on_calabria1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  calabria();
}


void
on_dedicato_a1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  dedica();
}


void
on_bNuovo_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_crea_nuovo_archivio(); 
}


void
on_bApri_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_carica_file();
}


void
on_bSalva_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_salva_file(NULL, NULL);
  rubrica_modificata(FALSE);
}


void
on_bAggiungi_clicked                   (GtkButton       *button,
                                        gpointer         data)
{
  GtkWidget *modulo;
  
  modulo = modulo_rubrica_new(NUOVO_MODULO);
  gtk_widget_show(modulo);
  rubrica_modificata(TRUE);
}


void
on_bElimina_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  gint scelta;
  gboolean cancellato;
  GtkCList *clist;
  InfoRubrica info;
  gchar *buffer, *mes;

  clist = rubrica_vista_get_schede();
  rubrica_vista_get_info(&info,VISTA_SCHEDE);

  if(!info.selezionato)
    errore_selezionare_elemento();
  else {
    gtk_clist_get_text(GTK_CLIST(clist), info.riga, 1, &buffer);

    mes = g_strdup_printf(_("Sei sicuro di voler eliminare\nla scheda %s?"), buffer);

    scelta = confermare_cancellazione(mes);
    g_free(mes);

    switch (scelta)
      {
      case 0:
	cancellato = rubrica_elimina_elemento(info.riga);
	
	if(!cancellato) 
	  /* c' stato un errore, e la scheda non  stata cancellata */
	  errore_cancellazione();
	else {
	  /* la scheda  cancellata, bisogna:
	     -- aggiornare il numero di elementi 
	        (fatto da rubrica_elimina_elemento)
	     -- aggiornare l'elenco delle schede 

	     elimino la scheda n info.riga 
	     e aggiorno la progressbar 	  */
	  rubrica_elimina_scheda(info.riga);
	  rubrica_modificata(TRUE);
	}
	break;
      case 1:   
      default:
	break;
      }    
  }
}


void
on_bModifica_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  InfoRubrica info;
  RubricaItem *r;

  rubrica_vista_get_info(&info, VISTA_SCHEDE);

  if(!info.selezionato)
    errore_selezionare_elemento();
  else {
    r = rubrica_prendi_elemento(info.riga);

    modulo_rubrica_modifica_elemento(r);  
    rubrica_modificata(TRUE);
  }
}


void
on_bPrima_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_mostra_prima_scheda();
}


void
on_bUltima_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_mostra_ultima_scheda();
}


void
on_bCerca_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_cerca_sheda();
}


void
on_exit_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
  esci();
}


void
on_bPrecedente_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_scheda_precedente();
}


void
on_bSuccessivo_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  rubrica_scheda_successiva();
}


void
on_schede_clist_select_row        (GtkCList        *clist,
				   gint             row,
				   gint             column,
				   GdkEventButton   *e,
				   gpointer         user_data)
{
  InfoRubrica info;

  g_return_if_fail(e != NULL);
  g_return_if_fail(GTK_IS_CLIST(clist));

  info.riga = row;
  info.colonna = column;
  info.selezionato = TRUE;   
  rubrica_vista_set_info(info, VISTA_SCHEDE);
  rubrica_set_scheda_corrente(row);

  /* un solo click
     visualizzare l'elemento e dare all'utente la 
     possibilit di modificare o cancellare l'elemento selezionato
  */
  if (e->type == GDK_BUTTON_RELEASE){
    RubricaItem *r; 
    
    r = rubrica_prendi_elemento(info.riga);
    rubrica_mostra_scheda(r);
    
    return;
  }
  
  /* doppio click
     l'utente deve modificare l'elemento selezionato
  */
  if(e->type == GDK_2BUTTON_PRESS){
    /*  
        RubricaItem *r; 
        
        r = rubrica_prendi_elemento(info.riga);
        rubrica_modifica_elemento(r);
    */
    GtkWidget *bot;
    
    bot = get_bModifica();

    gtk_signal_emit_by_name(GTK_OBJECT(bot), "clicked");
    
    return;
  }
  
  /* singolo click con il tasto destro del mouse
     visualizzo un menu
 
   if(((e->button & GDK_BUTTON3_MASK) == GDK_BUTTON3_MASK) && 
     (e->type == GDK_BUTTON_PRESS)){

    g_print("\npremuto il bottone di destra una volta");

    return;
  }
*/
}


void
on_dati_clist_select_row        (GtkCList        *clist,
				 gint             row,
				 gint             column,
				 GdkEventButton   *event,
				 gpointer         user_data)
{
}












