#include <gnome.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include "support.h"

#include "error.h"

void errore_selezionare_elemento(void)
{
  GtkWidget *messagebox;
  GtkWidget *dialog_vbox1;
  GtkWidget *button1;
  GtkWidget *dialog_action_area1;

  messagebox = gnome_message_box_new (_("Attenzione!\nE' necessario selezionare una\
               scheda,\nper poter procedere con l'elaborazione."), 
				      GNOME_MESSAGE_BOX_ERROR, NULL);
  gtk_object_set_data (GTK_OBJECT (messagebox), "messagebox", messagebox);
  gtk_container_set_border_width (GTK_CONTAINER (messagebox), 5);
  gtk_window_set_title (GTK_WINDOW (messagebox), _("Informazioni"));
  gtk_window_set_position (GTK_WINDOW (messagebox), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (messagebox), TRUE);
  gtk_window_set_policy (GTK_WINDOW (messagebox), FALSE, FALSE, FALSE);

  dialog_vbox1 = GNOME_DIALOG (messagebox)->vbox;
  gtk_object_set_data (GTK_OBJECT (messagebox), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  gnome_dialog_append_button (GNOME_DIALOG (messagebox), GNOME_STOCK_BUTTON_OK);
  button1 = g_list_last (GNOME_DIALOG (messagebox)->buttons)->data;
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (messagebox), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  dialog_action_area1 = GNOME_DIALOG (messagebox)->action_area;
  gtk_widget_ref (dialog_action_area1);
  gtk_object_set_data_full (GTK_OBJECT (messagebox), "dialog_action_area1", 
			    dialog_action_area1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(messagebox);
}

void errore_cancellazione(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new("Attenzione", GNOME_STOCK_BUTTON_OK, NULL);
  label = gtk_label_new(_("Attenzione!\nNon  stato possibile cancellare\nla \
scheda selezionata"));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));
}

void errore_modifica(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new("Attenzione", GNOME_STOCK_BUTTON_OK, NULL);
  label =  gtk_label_new(_("Attenzione!\nNon  stato possibile modificare\nla scheda \
selezionata"));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));
}


void non_implementato(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new("Attenzione", GNOME_STOCK_BUTTON_OK, NULL);
  label =  gtk_label_new(_("Attenzione!\nQuesta funzione non  ancora\nstata implementata"));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));  
}



















