#include <gnome.h>
#include <string.h>

#include "modulo.h"
#include "modulo_cb.h"
#include "modulo_int.h"
#include "support.h"


/*
void
on_check_cancellabile_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_check_modificabile_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}
*/

void
on_bot_web_aggiungi_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *m = user_data;
  GtkEntry *entry;
  GtkCList *clist;
  gchar *buffer[3];

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));

  buffer[0] = "";
  buffer[2] = NULL;

  entry = GTK_ENTRY(m->web);
  clist = GTK_CLIST(m->clist_web);

  gtk_widget_set_sensitive(GTK_WIDGET(m->web_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->web_cancella), FALSE);

  buffer[1] = gtk_entry_get_text(GTK_ENTRY(entry));
  gtk_clist_append(clist,buffer);
  gtk_entry_set_text(GTK_ENTRY(entry),"");
}


void
on_bot_web_modifica_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *m = user_data;
  gchar *buffer;
  
  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));

  /* click sul bottone modifica, allora l'entry contiene il
     valore da sostituire a quello corrente.
     Prendo il valore e lo sostituisco nella lista
  */
  
  buffer = gtk_entry_get_text(GTK_ENTRY(m->web));
  gtk_clist_set_text(GTK_CLIST(m->clist_web), m->webinfo.riga, 1, buffer);

  /* Pulisco l'entry, annullo il flag che memorizza la selezione della riga
     elimino la selezione della riga e rendo insensibile i bottoni
  */  
  m->webinfo.selezionato = FALSE;
  gtk_entry_set_text(GTK_ENTRY(m->web),"");
  gtk_widget_set_sensitive(GTK_WIDGET(m->web_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->web_cancella), FALSE);  

}


void
on_bot_web_elimina_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *m = user_data;

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));
  
  gtk_clist_remove(GTK_CLIST(m->clist_web), m->webinfo.riga);

  m->webinfo.selezionato = FALSE;
  gtk_entry_set_text(GTK_ENTRY(m->web), "");
  gtk_widget_set_sensitive(GTK_WIDGET(m->web_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->web_cancella), FALSE);  
}


void
on_web_clist_select_row        (GtkCList        *clist,
				gint             row,
				gint             column,
				GdkEvent        *event,
				gpointer         user_data)
{
  ModuloRubrica *m = user_data;
  gchar *buffer;

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));
  g_return_if_fail(GTK_IS_CLIST(clist));

  /*  stato selezionato un elemento della lista bisogna 
     sensibilizzare i bottoni modifica (e cancella) per permettere
     all'utente di operare la selezione voluta   

     Prelevo il contenuto della riga selezionata e lo rendo 
     disponibile nell' entry per l'eventuale modifica
  */
  gtk_clist_get_text(GTK_CLIST(clist), row, 1, &buffer);
  gtk_entry_set_text(GTK_ENTRY(m->web), buffer);
  gtk_widget_set_sensitive(GTK_WIDGET(m->web_modifica), TRUE);

  /* un solo click 
     l'utente pu modificare o cancellare l'elemento selezionato
     sensibilizzo modifica e cancella
  */
  if (event->type == GDK_BUTTON_RELEASE){
    m->webinfo.riga = row;
    m->webinfo.colonna = column;
    m->webinfo.selezionato = TRUE;    
    gtk_widget_set_sensitive(GTK_WIDGET(m->web_cancella), TRUE);

    return;
  }
  
  /* doppio click
     l'utente deve modificare l'elemento selezionato
     sensibilizzo solo il bottone modifica
  */
  if(event->type == GDK_2BUTTON_PRESS){
    m->webinfo.riga = row;
    m->webinfo.colonna = column;
    m->webinfo.selezionato = TRUE;     

    return;
  }
}

/*
void
on_web_clist_unselect_row      (GtkCList        *clist,
				gint             row,
				gint             column,
				GdkEvent        *event,
				gpointer         user_data)
{
  ModuloRubrica *m = user_data;

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));
  g_return_if_fail(GTK_IS_CLIST(clist));
  
  m->webinfo.selezionato = FALSE;    
  gtk_widget_set_sensitive(GTK_WIDGET(m->web_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->web_cancella), FALSE);
  gtk_clist_unselect_row(GTK_CLIST(m->clist_web), row,column);
  gtk_entry_set_text(GTK_ENTRY(m->web), "");
}
*/

void
on_bot_mail_aggiungi_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *m = user_data;
  GtkEntry *entry;
  GtkCList *clist;
  gchar *buffer[3];

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));

  buffer[0] = "";
  buffer[2] = NULL;

  entry = GTK_ENTRY(m->mail);
  clist = GTK_CLIST(m->clist_mail);

  gtk_widget_set_sensitive(GTK_WIDGET(m->mail_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->mail_cancella), FALSE);

  buffer[1] = gtk_entry_get_text(GTK_ENTRY(entry));
  gtk_clist_append(clist,buffer);
  gtk_entry_set_text(GTK_ENTRY(entry),"");
}


void
on_bot_mail_modifica_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *m = user_data;
  gchar *buffer;
  
  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));

  buffer = gtk_entry_get_text(GTK_ENTRY(m->mail));
  gtk_clist_set_text(GTK_CLIST(m->clist_mail), m->mailinfo.riga, 1, buffer);

  gtk_entry_set_text(GTK_ENTRY(m->mail),"");
/*
  gtk_clist_unselect_row(GTK_CLIST(m->clist_mail), m->mailinfo.riga, 
			 m->mailinfo.colonna);
*/
  m->mailinfo.selezionato = FALSE;
  gtk_widget_set_sensitive(GTK_WIDGET(m->mail_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->mail_cancella), FALSE);  
}


void
on_bot_mail_elimina_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *m = user_data;

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));
  
  gtk_clist_remove(GTK_CLIST(m->clist_mail), m->mailinfo.riga);
/*
  gtk_clist_unselect_row(GTK_CLIST(m->clist_mail), m->mailinfo.riga, 
			 m->mailinfo.colonna);
*/
  m->mailinfo.selezionato = FALSE;
  gtk_widget_set_sensitive(GTK_WIDGET(m->mail_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->mail_cancella), FALSE);  
}


void
on_mail_clist_select_row       (GtkCList        *clist,
				gint             row,
				gint             column,
				GdkEvent        *event,
				gpointer         user_data)
{
  ModuloRubrica *m = user_data;
  gchar *buffer;

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));
  g_return_if_fail(GTK_IS_CLIST(clist));

  gtk_clist_get_text(GTK_CLIST(clist), row, 1, &buffer);
  gtk_entry_set_text(GTK_ENTRY(m->mail), buffer);
  gtk_widget_set_sensitive(GTK_WIDGET(m->mail_modifica), TRUE);

  if (event->type == GDK_BUTTON_RELEASE){
    m->mailinfo.riga = row;
    m->mailinfo.colonna = column;
    m->mailinfo.selezionato = TRUE;    
    gtk_widget_set_sensitive(GTK_WIDGET(m->mail_cancella), TRUE);

    return;
  }
  
  if(event->type == GDK_2BUTTON_PRESS){
    m->mailinfo.riga = row;
    m->mailinfo.colonna = column;
    m->mailinfo.selezionato = TRUE;     

    return;
  }    
}

/*
void
on_mail_clist_unselect_row     (GtkCList        *clist,
				gint             row,
				gint             column,
				GdkEvent        *event,
				gpointer         user_data)
{

}
*/

void
on_radio_casa_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  modulo_set_telefono_attivo("Casa");
}

void
on_radio_ufficio_toggled                (GtkToggleButton *togglebutton,
					 gpointer         user_data)
{
  modulo_set_telefono_attivo("Ufficio");
}


void
on_radio_fax_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  modulo_set_telefono_attivo("Fax");
}


void
on_radio_cellulare_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  modulo_set_telefono_attivo("Cellulare");
}


/*
void
on_telefono_clist_unselect_row (GtkCList        *clist,
				gint             row,
				gint             column,
				GdkEvent        *event,
				gpointer         user_data)
{

}
*/


void
on_telefono_clist_select_row   (GtkCList        *clist,
				gint             row,
				gint             column,
				GdkEvent        *event,
				gpointer         user_data)
{
  ModuloRubrica *m = user_data;
  gchar *buffer[2];
  gint tipo;

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));
  g_return_if_fail(GTK_IS_CLIST(clist));

  gtk_clist_get_text(GTK_CLIST(clist), row, 1, &buffer[0]);
  gtk_clist_get_text(GTK_CLIST(clist), row, 2, &buffer[1]);

  gtk_entry_set_text(GTK_ENTRY(m->telefono), buffer[0]);
  tipo = tipo_telefono_int(buffer[1]);
  switch (tipo)
    {
    case TELEFONO_CASA:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(m->radio_casa), TRUE);
      break;
    case TELEFONO_UFFICIO:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(m->radio_ufficio), TRUE);
      break;
    case TELEFONO_FAX:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(m->radio_fax), TRUE);
      break;
    case TELEFONO_CELLULARE:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(m->radio_cellulare), TRUE);
      break; 
    default:
      break;
    }
 
  gtk_widget_set_sensitive(GTK_WIDGET(m->telefono_modifica), TRUE);

  /* un solo click
   */
  if (event->type == GDK_BUTTON_RELEASE){
    m->telinfo.riga = row;
    m->telinfo.colonna = column;
    m->telinfo.selezionato = TRUE;    
    gtk_widget_set_sensitive(GTK_WIDGET(m->telefono_cancella), TRUE);

    return;
  }
  
  /* doppio click
   */
  if(event->type == GDK_2BUTTON_PRESS){
    m->telinfo.riga = row;
    m->telinfo.colonna = column;
    m->telinfo.selezionato = TRUE;     

    return;
  }
}


void
on_bot_tel_aggiungi_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *m = user_data;
  GtkEntry *entry;
  GtkCList *clist;
  gchar *buffer[4];

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));

  entry = GTK_ENTRY(m->telefono);
  clist = GTK_CLIST(m->clist_telefono);

  gtk_widget_set_sensitive(GTK_WIDGET(m->telefono_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->telefono_cancella), FALSE);

  buffer[0] = "";        // eventuale pixmap
  buffer[1] = gtk_entry_get_text(GTK_ENTRY(entry));
  buffer[2] = modulo_get_telefono_attivo();
  buffer[3] = NULL;      // file della lista

  gtk_clist_append(clist,buffer);
  gtk_entry_set_text(GTK_ENTRY(entry),"");
}


void
on_bot_tel_modifica_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *m = user_data;
  gchar *buffer[2];
  
  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));

  buffer[0] = gtk_entry_get_text(GTK_ENTRY(m->telefono));
  buffer[1] = modulo_get_telefono_attivo();

  gtk_clist_set_text(GTK_CLIST(m->clist_telefono), m->telinfo.riga, 1, buffer[0]);
  gtk_clist_set_text(GTK_CLIST(m->clist_telefono), m->telinfo.riga, 2, buffer[1]);

  gtk_entry_set_text(GTK_ENTRY(m->telefono),"");

  m->telinfo.selezionato = FALSE;
  gtk_widget_set_sensitive(GTK_WIDGET(m->telefono_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->telefono_cancella), FALSE);  
}


void
on_bot_tel_elimina_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *m = user_data;

  g_return_if_fail(m != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(m));
  
  gtk_clist_remove(GTK_CLIST(m->clist_telefono), m->telinfo.riga);

  m->telinfo.selezionato = FALSE;
  gtk_widget_set_sensitive(GTK_WIDGET(m->telefono_modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(m->telefono_cancella), FALSE);  
}









